<?php


namespace FiloBlu\FixFlatTablePrice\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class Run extends Command
{

    protected $_core;
    protected $_state;

    public function __construct(
        \FiloBlu\FixFlatTablePrice\Model\Core $core,
        \Magento\Framework\App\State $state,
        $name = null
    )
    {
        $this->_core = $core;
        $this->_state = $state;
        parent::__construct($name);
    }


    /**
     * {@inheritdoc}
     */
    protected function execute(InputInterface $input, OutputInterface $output) {
        $this->ensureAreaCode($output);
        $output->writeln("Please check the logs: ".$this->_core->getLogPath());
        $this->_core->run();
    }

    /**
     * {@inheritdoc}
     */
    protected function configure()
    {
        $this->setName("filoblu:fixflattableprice:run");
        $this->setDescription("Run price checks on the flat tables");
    }

    protected function ensureAreaCode(OutputInterface $output)
    {
        try {
            $this->_state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $currentAreaCode = $this->_state->getAreaCode();
            $output->writeln("Area code was already set to {$currentAreaCode}");
        }
    }

}