<?php

namespace FiloBlu\FixFlatTablePrice\Model;

class Core  {

    protected $_storeManager;
    protected $_resource;

    public $_logpath = '/var/log/fix_flat_table_price.log';

    public function __construct(
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Framework\App\ResourceConnection $resource
    )
    {
        $this->_storeManager = $storeManager;
        $this->_resource = $resource;
    }

    public function getLogPath(){
        return $this->_logpath;
    }

    public function run(){

        $writer = new \Zend\Log\Writer\Stream(BP . $this->_logpath);
        $logger = new \Zend\Log\Logger();
        $logger->addWriter($writer);
        $logger->info("Start!");

        $storeManagerDataList = $this->_storeManager->getStores();

        foreach ($storeManagerDataList as $key => $store) {
            $store_id = $store['store_id'];

            try {

                $sql = "SELECT attribute_id FROM eav_attribute WHERE attribute_code = 'price' AND entity_type_id = 4";
                $price_attribute_id = $this->_resource->getConnection()->fetchRow($sql);
                $price_attribute_id = $price_attribute_id['attribute_id'];

                $sql = "SELECT CPFX.row_id,CPFX.entity_id,CPFX.sku,CPFX.price,CPED.value AS 'price_eav',CPE.type_id
                    FROM catalog_product_flat_{$store_id} CPFX
                    LEFT JOIN catalog_product_entity_decimal CPED ON CPED.row_id = CPFX.row_id AND CPED.store_id = {$store_id} AND CPED.attribute_id = {$price_attribute_id} 
                    LEFT JOIN catalog_product_entity CPE ON CPE.row_id = CPFX.row_id
                    WHERE CPFX.price <> CPED.value 
                    #AND CPE.type_id = 'simple' 
                    AND CPED.value IS NOT NULL 
                    AND CPED.value > 0 ";
                $result = $this->_resource->getConnection()->fetchAll($sql);

                if(count($result) == 0){
                    $logger->info("Store ID {$store_id} all prices are good!");
                    continue;
                }

                foreach ($result as $price_data) {
                    $sql = "UPDATE catalog_product_flat_{$store_id} 
                            SET price = '{$price_data['price_eav']}' 
                            WHERE row_id = '{$price_data['row_id']}' AND price <> '{$price_data['price_eav']}'";
                    $logger->info($sql);
                    $this->_resource->getConnection()->query($sql);
                }

            } catch (\Exception $e) {
                $logger->info($e->getMessage());
            }
        }
        $logger->info("Done!\n");

    }

}